#include "PDFTextString.h"
#include "UnicodeString.h"
#include "PDFWriter.h"
#include "PDFPage.h"
#include "PDFRectangle.h"
#include "PageContentContext.h"
#include <iostream>
#include <string>

using namespace std;
using namespace PDFHummus;


int main(int argc, char* argv[]) {

  EStatusCode status = eSuccess;

  PDFWriter pdfWriter;
  status = pdfWriter.StartPDF("/tmp/SimpleTextUsage.pdf",ePDFVersion13);

  if( status != eSuccess ) {
    std::cout << "Failed to start pdf" << std::endl;
    return 1;
  }

  PDFPage* page = new PDFPage();
  page->SetMediaBox(PDFRectangle(0,0,595,842));
  PageContentContext* contentContext = pdfWriter.StartPageContentContext(page);
  PDFUsedFont* font = pdfWriter.GetFontForFile("/usr/share/fonts/opentype/tlwg/Waree.otf");
  AbstractContentContext::TextOptions textOptions(font,
                          32,
                          AbstractContentContext::eGray,
                          0);

  // PDFUsedFont::TextMeasures textDimensions = arialFont->CalculateTextDimensions("Hello World",14);

  // contentContext->WriteText(100,10,"Hello World",textOptions);
  contentContext->BT();
  contentContext->k(0,0,0,1);
  contentContext->Tf(font, 1);
  contentContext->Tm(30,0,0,30,78.4252,662.8997 - 1*100);

  contentContext->Tj("Amr Shahin AKA (\xD8\xB9\xD8\xB9\xD8\xB9)");
  // UnicodeString aString;
  // aString.FromUTF8(u8"ععع");
  // PDFTextString latinSpecialString;
  // latinSpecialString.FromUTF8(aString.ToUTF8().second);

  // contentContext->WriteText(50, 200, u8"ععع", textOptions);

  // contentContext->WriteText(50, 200, u8"ععع", textOptions);
  // contentContext->TjWriteText(200,150,"\xD8\xB9\xD8\xB9\xD8\xB9",textOptions);
  std::cout << "added: \"\xD8\xB9\xD8\xB9\xD8\xB9\"" << std::endl;
  // contentContext->WriteText(200,350,"\U0001f34c",textOptions);


	status = pdfWriter.EndPageContentContext(contentContext);
	if(status != eSuccess)
	{
		cout<<"Failed to end content context\n";
    return 1;
	}

  status = pdfWriter.WritePageAndRelease(page);
  if(status != eSuccess)
  {
    status = PDFHummus::eFailure;
    cout<<"Failed to write page\n";
    return 1;
  }


  status = pdfWriter.EndPDF();
  if(status != eSuccess)
  {
    status = PDFHummus::eFailure;
    cout<<"Failed to end pdf\n";
    return 1;
  }

  return 0;
  //
  //
  // PDFWriter pdfWriter;
  // pdfWriter.StartPDF("/tmp/SimpleTextUsage.PDF",ePDFVersion13);
  // PDFPage* page = new PDFPage();
  // page->SetMediaBox(PDFRectangle(0,0,595,842));
  // PageContentContext* contentContext = pdfWriter.StartPageContentContext(page);
  //
  //
  // //prepare the text
  // PDFUsedFont* font = pdfWriter.GetFontForFile("/usr/share/fonts/opentype/stix/STIXIntegralsD-Regular.otf");
  //
  // AbstractContentContext::TextOptions textOptions(font,14,AbstractContentContext::eGray,0);
  // contentContext->WriteText(10,100,"Hello World",textOptions);
  //
  // pdfWriter.EndPageContentContext(contentContext);
  // pdfWriter.WritePageAndRelease(page);
  // pdfWriter.EndPDF();


}
